#ifndef _ELEVATOR_H
#define _ELEVATOR_H

//elevator only knows if the door has hit a limit
//also knows if something is in the way
//if a button has been pushed and which one it is
typedef struct
{
	/* non-zero if something is in the way */
	char obstacle;
	
	/* non-zero if the button has been pressed */
	unsigned char buttons[6];
	
	/* true if a limit has been reached
		-1 if open limit reached,
		1 if closed limit reached */
	char limit;
	
	/* power the door in a given direction
		negative values open the door,
		positive values close it,
		0 leaves it where it is */
	char doorMotor;
	
	/* elevator door position
		0 is completely open, 100 is closed 
		beyond that is a failure */
	char doorPosition;
	
	/* nonzero if the elevator has been broken */
	char broken;
} Elevator;

void RunElevator(Elevator *e);

extern unsigned char ELEVATOR_CAPACITY;

extern char DoorMotor;
extern char ObstacleDetected;
extern char DoorLimit;
extern char DoorOpenButton;
extern char DoorCloseButton;
#endif
