#include <stdio.h>

#include "robot.h"

/****************************
 * I/O variables.
 * Don't change these definitions.
 */

/* The desired velocity in the direction of the robot.
 * Negative values make it move backwards.
 */
char robot_forward;

/* The desired rotational velocity.  Positive is clockwise. */
char robot_turn;

/* The current speed of the robot in its current direction. */
char robot_current_velocity;

/* The current angle of the robot is degrees clockwise from right.
 * Always on [0, 359].
 */
int robot_current_angle;

/* Nonzero if the robot is touching something */
char robot_hit;

/* Nonzero if the robot sees something */
char robot_sense;

/* The waypoint that the robot is touching or zero if none.
 * If the robot is touching more than one waypoint, this number will be one of them, but
 * I make no guarantees about which one it will be.
 */
int robot_waypoint;

/* This is the number shown after "State" on the screen.
 * It is not used for any purpose other than display.
 * It can mean whatever you want.
 */
int robot_state;

/****************************
 * Put your global variables here.
 */

int countdown;
int state;

/* These are used to switch easily between robot behaviors. */
void robot1(void);
void robot2(void);

void robot_run()
{
    //hahahah
}

void robot1()
{
    /* State changes */
    switch (state)
    {
        case 0:     /* Moving freely */
            if (robot_hit)
            {
                countdown = 12;
                state = 1;
            }
            break;
        case 1:     /* Hit a wall */
            if (countdown == 0)
            {
                countdown = 100;
                state = 2;
            } else {
                countdown--;
            }
            break;
        case 2:     /* Finished turning, but still on the wall */
            if (!robot_hit)
            {
                /* Can start driving normally now */
                state = 0;
            }
            countdown--;
            if (!countdown)
            {
                state = 0;
            }
            break;
    }

    /* Outputs */
    switch (state)
    {
        case 0:
        case 2:
            /* Forward */
            robot_forward = 127;
            robot_turn = 0;
            break;
        case 1:
            /* Turning CW */
            robot_forward = 0;
            robot_turn = 127;
            break;
    }
}

void robot2()
{
    /* State change */
    if (countdown)
    {
        countdown--;
    } else {
        state++;

        /* New countdown */
        switch (state)
        {
            case 1:
                countdown = 15;
                break;
            case 2:
                countdown = 50;
                break;
            case 3:
                countdown = 23;
                break;
            case 4:
                countdown = 28;
                break;
        }
    }

    /* Outputs */
    switch (state)
    {
        case 2:
        case 4:
            /* Forward */
            robot_forward = 127;
            robot_turn = 0;
            break;
        case 0:
        case 1:
            /* Turning CW */
            robot_forward = 0;
            robot_turn = 127;
            break;
        case 3:
            /* Turning CCW */
            robot_forward = 0;
            robot_turn = -127;
            break;
        default:
            robot_forward = 0;
            robot_turn = 0;
            break;
    }

    /* Make the state be shown on the screen */
    robot_state = state;
}
