#ifndef _ROBOT_H_
#define _ROBOT_H_

/* The desired velocity in the direction of the robot.
 * Negative values make it move backwards.
 */
extern char robot_forward;

/* The desired rotational velocity.  Positive is clockwise. */
extern char robot_turn;

/* The current speed of the robot in its current direction. */
extern char robot_current_velocity;

/* The current angle of the robot is degrees clockwise from right.
 * Always on [0, 359].
 */
extern int robot_current_angle;

/* Nonzero if the robot is touching something */
extern char robot_hit;

/* Nonzero if the robot sees something */
extern char robot_sense;

/* The waypoint that the robot is touching or zero if none.
 * If the robot is touching more than one waypoint, this number will be one of them, but
 * I make no guarantees about which one it will be.
 */
extern int robot_waypoint;

/* This is the number shown after "State:" on the screen.
 * It is not used for any purpose other than display.
 * It can mean whatever you want.
 */
extern int robot_state;

void robot_run(void);

#endif /* _ROBOT_H_ */
